Index: coreboot-poulsbo/Makefile
===================================================================
--- coreboot-poulsbo.orig/Makefile	2010-12-15 12:32:42.566455002 +0100
+++ coreboot-poulsbo/Makefile	2010-12-15 12:38:55.556455001 +0100
@@ -184,6 +184,7 @@
 romstage-srcs:=
 driver-srcs:=
 smm-srcs:=
+cbfs-files:=
 
 ramstage-objs:=
 romstage-objs:=
@@ -197,11 +198,20 @@
 includemakefiles= \
 	$(foreach type,$(2), $(eval $(type)-y:=)) \
 	$(eval subdirs-y:=) \
+	$(eval cbfs-files-y:=) \
 	$(eval -include $(1)) \
 	$(foreach type,$(2), \
 		$(eval $(type)-srcs+= \
 			$$(subst $(top)/,, \
 			$$(abspath $$(addprefix $(dir $(1)),$$($(type)-y)))))) \
+	$(foreach file,$(cbfs-files-y), \
+		$(if $(wildcard $(dir $(1))$(file)), \
+			$(eval tmp-cbfs-file:= $(wildcard $(dir $(1))$(file))), \
+			$(eval tmp-cbfs-file:= $(file))) \
+		$(eval cbfs-files += $(tmp-cbfs-file)|$$($(file)-name)|$$($(file)-type)|$$($(file)-position)) \
+		$(eval $(file)-name:=) \
+		$(eval $(file)-type:=) \
+		$(eval $(file)-position:=)) \
 	$(eval subdirs+=$$(subst $(CURDIR)/,,$$(abspath $$(addprefix $(dir $(1)),$$(subdirs-y)))))
 
 # For each path in $(subdirs) call includemakefiles
@@ -275,6 +285,7 @@
 	@echo allsrcs=$(allsrcs)
 	@echo DEPENDENCIES=$(DEPENDENCIES)
 	@echo LIBGCC_FILE_NAME=$(LIBGCC_FILE_NAME)
+	@echo cbfs-files:='$(cbfs-files)'
 
 printcrt0s:
 	@echo crt0s=$(crt0s)
Index: coreboot-poulsbo/src/arch/x86/Makefile.bigbootblock.inc
===================================================================
--- coreboot-poulsbo.orig/src/arch/x86/Makefile.bigbootblock.inc	2010-12-15 12:32:42.476455002 +0100
+++ coreboot-poulsbo/src/arch/x86/Makefile.bigbootblock.inc	2010-12-15 12:32:43.896455000 +0100
@@ -3,7 +3,7 @@
 
 $(obj)/coreboot.pre: $(obj)/coreboot.bootblock $(CBFSTOOL)
 	rm -f $@
-	$(CBFSTOOL) $@ create $(CONFIG_COREBOOT_ROMSIZE_KB)K $(obj)/coreboot.bootblock
+	cp $(obj)/coreboot.pre1 $@
 
 #######################################################################
 # Build the bootblock
Index: coreboot-poulsbo/src/arch/x86/Makefile.bootblock.inc
===================================================================
--- coreboot-poulsbo.orig/src/arch/x86/Makefile.bootblock.inc	2010-12-15 12:32:42.526455002 +0100
+++ coreboot-poulsbo/src/arch/x86/Makefile.bootblock.inc	2010-12-15 12:32:43.896455000 +0100
@@ -1,15 +1,6 @@
 #######################################################################
 # Build the final rom image
 
-ifneq ($(CONFIG_UPDATE_IMAGE),y)
-$(obj)/coreboot.pre1: $(obj)/coreboot.bootblock $(CBFSTOOL)
-	rm -f $@
-	$(CBFSTOOL) $@ create $(CONFIG_COREBOOT_ROMSIZE_KB)K $(obj)/coreboot.bootblock
-else
-$(obj)/coreboot.pre1: $(CBFSTOOL)
-	mv $(obj)/coreboot.rom $@
-endif
-
 $(obj)/coreboot.pre: $(obj)/coreboot.romstage $(obj)/coreboot.pre1 $(CBFSTOOL)
 	rm -f $@
 	cp $(obj)/coreboot.pre1 $@
Index: coreboot-poulsbo/src/arch/x86/Makefile.inc
===================================================================
--- coreboot-poulsbo.orig/src/arch/x86/Makefile.inc	2010-12-15 12:32:42.446455002 +0100
+++ coreboot-poulsbo/src/arch/x86/Makefile.inc	2010-12-15 12:32:43.896455000 +0100
@@ -53,6 +53,22 @@
 COREBOOT_ROM_DEPENDENCIES+=$(CONFIG_VSA_FILENAME)
 endif
 
+extract_nth=$(word $(1), $(subst |, ,$(2)))
+
+ifneq ($(CONFIG_UPDATE_IMAGE),y)
+prebuild-files = \
+	$(foreach file,$(cbfs-files), \
+		$(CBFSTOOL) $@ add $(call extract_nth,1,$(file)) $(call extract_nth,2,$(file)) $(call extract_nth,3,$(file)) $(call extract_nth,4,$(file)); )
+
+$(obj)/coreboot.pre1: $(obj)/coreboot.bootblock $(CBFSTOOL)
+	rm -f $@
+	$(CBFSTOOL) $@ create $(CONFIG_COREBOOT_ROMSIZE_KB)K $(obj)/coreboot.bootblock
+	$(prebuild-files)
+else
+$(obj)/coreboot.pre1: $(CBFSTOOL)
+	mv $(obj)/coreboot.rom $@
+endif
+
 $(obj)/coreboot.rom: $(obj)/coreboot.pre $(obj)/coreboot_ram $(CBFSTOOL) $(call strip_quotes,$(COREBOOT_ROM_DEPENDENCIES))
 	@printf "    CBFS       $(subst $(obj)/,,$(@))\n"
 	cp $(obj)/coreboot.pre $@.tmp
